package se.fnord.ecalc.parser.functions;

import se.fnord.ecalc.parser.ExpressionContext;
import se.fnord.ecalc.parser.ExpressionException;
import se.fnord.ecalc.parser.IFunction;
import se.fnord.ecalc.parser.IValue;

public class Minimum implements IFunction {


	public IValue execute(IValue[] params, ExpressionContext context)
			throws ExpressionException {
		// TODO: Probably not correct to treat all types at doubles.
		if (params == null || params.length == 0)
			throw new ExpressionException("%se.fnord.ecalc.exceptions.expressionexception.arity");
		
		int i;
		IValue min = params[0];
		double min_v = min.toDouble();
		for (i = 1; i < params.length; i++) {
			if (min_v > params[i].toDouble()) {
				min = params[i];
				min_v = params[i].toDouble();
			}
		}

		return min; 
	}
}
