package se.fnord.ecalc.parser;

public interface IOperators {

	public final static int ANGLE_RAD = 1;
	public final static int ANGLE_DEG = 2;
	
	public abstract IValue add(IValue v) throws ExpressionException;

	public abstract IValue subtract(IValue v) throws ExpressionException;

	public abstract IValue multiply(IValue v) throws ExpressionException;

	public abstract IValue divide(IValue v) throws ExpressionException;

	public abstract IValue modulus(IValue v) throws ExpressionException;

	public abstract IValue power(IValue v) throws ExpressionException;
	public abstract IValue shift_left(IValue v) throws ExpressionException;
	public abstract IValue shift_right(IValue v) throws ExpressionException;
	public abstract IValue bitwise_and(IValue v) throws ExpressionException;
	public abstract IValue bitwise_or(IValue v) throws ExpressionException;
	public abstract IValue negate();

}