/* $Id: IValue.java,v 1.4 2006/03/24 18:11:41 gsson Exp $ */

/*
 * Copyright (c) 2006 Henrik Gustafsson <henrik.gustafsson@fnord.se>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

package se.fnord.ecalc.parser;

public interface IValue {
	static final int TYPE_UNDEFINED = 0;
	static final int TYPE_AUTO = 0;
	static final int TYPE_LONG = 1;
	static final int TYPE_DOUBLE = 2;
	
	int getPreferredType() throws ExpressionException;
	double toDouble() throws ExpressionException;
	long toLong() throws ExpressionException;
	Literal ensureType(int type) throws ExpressionException;

	/*
	void fromDouble(double value);
	void fromLong(long value);
	void fromIValue(IValue value);

	IValue add(IValue v);
	IValue subtract(IValue v);
	IValue multiply(IValue v);
	IValue divide(IValue v);
	IValue modulus(IValue v);
	IValue power(IValue v);
	IValue negate();
	*/
	
	
}
